searchData={"items":[{"type":"module","title":"euneus","doc":"Core module to parse and generate JSON.","ref":"euneus.html"},{"type":"function","title":"euneus.decode/1","doc":null,"ref":"euneus.html#decode/1"},{"type":"function","title":"euneus.decode/2","doc":null,"ref":"euneus.html#decode/2"},{"type":"function","title":"euneus.encode/1","doc":null,"ref":"euneus.html#encode/1"},{"type":"function","title":"euneus.encode/2","doc":null,"ref":"euneus.html#encode/2"},{"type":"function","title":"euneus.encode_to_binary/1","doc":null,"ref":"euneus.html#encode_to_binary/1"},{"type":"function","title":"euneus.encode_to_binary/2","doc":null,"ref":"euneus.html#encode_to_binary/2"},{"type":"module","title":"euneus_decoder","doc":"Decode JSON to Erlang terms.","ref":"euneus_decoder.html"},{"type":"function","title":"euneus_decoder.decode/2","doc":null,"ref":"euneus_decoder.html#decode/2"},{"type":"function","title":"euneus_decoder.handle_error/3","doc":null,"ref":"euneus_decoder.html#handle_error/3"},{"type":"function","title":"euneus_decoder.resume/6","doc":null,"ref":"euneus_decoder.html#resume/6"},{"type":"function","title":"euneus_decoder.resume/7","doc":null,"ref":"euneus_decoder.html#resume/7"},{"type":"type","title":"euneus_decoder.error_class/0","doc":null,"ref":"euneus_decoder.html#t:error_class/0"},{"type":"type","title":"euneus_decoder.error_handler/0","doc":null,"ref":"euneus_decoder.html#t:error_handler/0"},{"type":"type","title":"euneus_decoder.error_reason/0","doc":null,"ref":"euneus_decoder.html#t:error_reason/0"},{"type":"type","title":"euneus_decoder.error_stacktrace/0","doc":null,"ref":"euneus_decoder.html#t:error_stacktrace/0"},{"type":"type","title":"euneus_decoder.input/0","doc":null,"ref":"euneus_decoder.html#t:input/0"},{"type":"type","title":"euneus_decoder.normalizer/1","doc":null,"ref":"euneus_decoder.html#t:normalizer/1"},{"type":"type","title":"euneus_decoder.options/0","doc":null,"ref":"euneus_decoder.html#t:options/0"},{"type":"type","title":"euneus_decoder.position/0","doc":null,"ref":"euneus_decoder.html#t:position/0"},{"type":"type","title":"euneus_decoder.result/0","doc":null,"ref":"euneus_decoder.html#t:result/0"},{"type":"module","title":"euneus_encoder","doc":"Encode Erlang terms to JSON.","ref":"euneus_encoder.html"},{"type":"function","title":"euneus_encoder.encode/2","doc":null,"ref":"euneus_encoder.html#encode/2"},{"type":"function","title":"euneus_encoder.encode_atom/2","doc":null,"ref":"euneus_encoder.html#encode_atom/2"},{"type":"function","title":"euneus_encoder.encode_binary/2","doc":null,"ref":"euneus_encoder.html#encode_binary/2"},{"type":"function","title":"euneus_encoder.encode_datetime/2","doc":null,"ref":"euneus_encoder.html#encode_datetime/2"},{"type":"function","title":"euneus_encoder.encode_float/2","doc":null,"ref":"euneus_encoder.html#encode_float/2"},{"type":"function","title":"euneus_encoder.encode_integer/2","doc":null,"ref":"euneus_encoder.html#encode_integer/2"},{"type":"function","title":"euneus_encoder.encode_list/2","doc":null,"ref":"euneus_encoder.html#encode_list/2"},{"type":"function","title":"euneus_encoder.encode_map/2","doc":null,"ref":"euneus_encoder.html#encode_map/2"},{"type":"function","title":"euneus_encoder.encode_timestamp/2","doc":null,"ref":"euneus_encoder.html#encode_timestamp/2"},{"type":"function","title":"euneus_encoder.encode_unhandled/2","doc":null,"ref":"euneus_encoder.html#encode_unhandled/2"},{"type":"function","title":"euneus_encoder.escape_binary/2","doc":null,"ref":"euneus_encoder.html#escape_binary/2"},{"type":"function","title":"euneus_encoder.escape_byte/1","doc":null,"ref":"euneus_encoder.html#escape_byte/1"},{"type":"function","title":"euneus_encoder.escape_html/1","doc":null,"ref":"euneus_encoder.html#escape_html/1"},{"type":"function","title":"euneus_encoder.escape_js/1","doc":null,"ref":"euneus_encoder.html#escape_js/1"},{"type":"function","title":"euneus_encoder.escape_json/1","doc":null,"ref":"euneus_encoder.html#escape_json/1"},{"type":"function","title":"euneus_encoder.escape_unicode/1","doc":null,"ref":"euneus_encoder.html#escape_unicode/1"},{"type":"function","title":"euneus_encoder.handle_error/3","doc":null,"ref":"euneus_encoder.html#handle_error/3"},{"type":"function","title":"euneus_encoder.throw_unsupported_type_error/1","doc":null,"ref":"euneus_encoder.html#throw_unsupported_type_error/1"},{"type":"type","title":"euneus_encoder.encoder/1","doc":null,"ref":"euneus_encoder.html#t:encoder/1"},{"type":"type","title":"euneus_encoder.error_class/0","doc":null,"ref":"euneus_encoder.html#t:error_class/0"},{"type":"type","title":"euneus_encoder.error_handler/0","doc":null,"ref":"euneus_encoder.html#t:error_handler/0"},{"type":"type","title":"euneus_encoder.error_reason/0","doc":null,"ref":"euneus_encoder.html#t:error_reason/0"},{"type":"type","title":"euneus_encoder.error_stacktrace/0","doc":null,"ref":"euneus_encoder.html#t:error_stacktrace/0"},{"type":"type","title":"euneus_encoder.escaper/1","doc":null,"ref":"euneus_encoder.html#t:escaper/1"},{"type":"type","title":"euneus_encoder.input/0","doc":null,"ref":"euneus_encoder.html#t:input/0"},{"type":"type","title":"euneus_encoder.options/0","doc":null,"ref":"euneus_encoder.html#t:options/0"},{"type":"type","title":"euneus_encoder.result/0","doc":null,"ref":"euneus_encoder.html#t:result/0"},{"type":"extras","title":"Overview","doc":"# Euneus\n\nA JSON parser and generator in pure Erlang.\n\nEuneus is a rewrite of [Thoas][thoas].\n\nLike Thoas, both the parser and generator fully conform to\n[RFC 8259](https://tools.ietf.org/html/rfc8259) and\n[ECMA 404](http://www.ecma-international.org/publications/standards/Ecma-404.htm).","ref":"readme.html"},{"type":"extras","title":"Table of Contents - Overview","doc":"- [Installation](#installation)\n    - [Erlang](#erlang)\n    - [Elixir](#elixir)\n- [Basic Usage](#basic-usage)\n- [Data Mapping](#data-mapping)\n    - [Why not more built-in types?](#why-not-more-built-in-types)\n- [Differences to Thoas](#differences-to-thoas)\n    - [Encode](#encode)\n    - [Decode](#decode)\n        - [Resuming](#resuming)\n    - [Why Euneus over Thoas?](#why-euneus-over-thoas)\n- [Benchmarks](#benchmarks)\n    - [Encode](#encode-1)\n    - [Decode](#decode-1)\n- [Credits](#credits)\n- [Why the name Euneus?](#why-the-name-euneus)\n- [TODO](#todo)\n- [Sponsors](#sponsors)\n- [Contributing](#contributing)\n    - [Issues](#issues)\n    - [Installation](#installation-1)\n    - [Commands](#commands)\n- [License](#license)","ref":"readme.html#table-of-contents"},{"type":"extras","title":"Installation - Overview","doc":"#","ref":"readme.html#installation"},{"type":"extras","title":"Erlang - Overview","doc":"```erlang\n% rebar.config\n{deps, [euneus]}\n```\n\n#","ref":"readme.html#erlang"},{"type":"extras","title":"Elixir - Overview","doc":"```elixir\n# mix.exs\ndef deps do\n  [{:euneus, \"~> 0.4\"}]\nend\n```","ref":"readme.html#elixir"},{"type":"extras","title":"Basic Usage - Overview","doc":"```erlang\n1> {ok, JSON} = euneus:encode_to_binary(#{name => #{english =>  >, japanese =>  >}, caught_at => erlang:timestamp(), type => [fire], profile => #{height => 0.6, weight => 8}, ability => #{0 =>  >, 1 => undefined}}).\n{ok,  >}\n\n2> euneus:decode(JSON).\n{ok,#{ > =>\n          #{ > =>  >, > => undefined},\n       > => {1698,126333,753000},\n       > =>\n          #{ > =>  >,\n             > =>\n                 >},\n       > => #{ > => 0.6, > => 8},\n       > => [ >]}}\n\n3> euneus:decode(JSON, #{\n    keys => fun\n        ( > = Key, _Opts) when Char >= $0, Char = \n            binary_to_integer(Key);\n        (Key, _Opts) ->\n            binary_to_existing_atom(Key)\n    end\n}).\n{ok,#{name =>\n          #{english =>  >,\n            japanese =>\n                 >},\n      profile => #{height => 0.6,weight => 8},\n      type => [ >],\n      caught_at => {1698,126333,753000},\n      ability => #{0 =>  >,1 => undefined}}}\n```","ref":"readme.html#basic-usage"},{"type":"extras","title":"Data Mapping - Overview","doc":"| **Erlang ->**        \t| **Encode Options ->**                                                                                                                                    \t| **JSON ->**                 \t| **Decode Options ->**                                                                                                    \t| **Erlang**           \t|\n|----------------------\t|----------------------------------------------------------------------------------------------------------------------------------------------------------\t|-----------------------------\t|--------------------------------------------------------------------------------------------------------------------------\t|----------------------\t|\n| undefined            \t| #{}                                                                                                                                                      \t| null                        \t| #{}                                                                                                                      \t| undefined            \t|\n| true                 \t| #{}                                                                                                                                                      \t| true                        \t| #{}                                                                                                                      \t| true                 \t|\n| false                \t| #{}                                                                                                                                                      \t| false                       \t| #{}                                                                                                                      \t| false                \t|\n| abc                  \t| #{}                                                                                                                                                      \t| \"abc\"                       \t| #{}                                                                                                                      \t|  >            \t|\n| \"abc\"                \t| #{}                                                                                                                                                      \t| [97,98,99]                  \t| #{}                                                                                                                      \t| \"abc\"                \t|\n|  >            \t| #{}                                                                                                                                                      \t| \"abc\"                       \t| #{}                                                                                                                      \t|  >            \t|\n| {{1970,1,1},{0,0,0}} \t| #{}                                                                                                                                                      \t| \"1970-01-01T00:00:00Z\"      \t| #{}                                                                                                                      \t| {{1970,1,1},{0,0,0}} \t|\n| {0,0,0}              \t| #{}                                                                                                                                                      \t| \"1970-01-01T00:00:00.000Z\"  \t| #{}                                                                                                                      \t| {0,0,0}              \t|\n| 123                  \t| #{}                                                                                                                                                      \t| 123                         \t| #{}                                                                                                                      \t| 123                  \t|\n| 123.45600            \t| #{}                                                                                                                                                      \t| 123.456                     \t| #{}                                                                                                                      \t| 123.456              \t|\n| [true,0,undefined]   \t| #{}                                                                                                                                                      \t| [true,0,null]               \t| #{null_term => nil}                                                                                                      \t| [true,0,nil]         \t|\n| #{foo => bar}        \t| #{}                                                                                                                                                      \t| {\"foo\":\"bar\"}               \t| #{keys => fun(Key, _Opts) -> binary_to_atom(Key) end}                                                           \t| #{foo =>  >}  \t|\n| {myrecord, val}      \t| #{encode_unhandled => fun({myrecord, Val}, Opts) ->     Encode = maps:get(encode_list, Opts),     Encode([myrecord, #{key => Val}], Opts) end}) \t| [\"myrecord\", {\"key\":\"val\"}] \t| #{arrays => fun([ >, #{ > := Val}], _Opts) ->     {myrecord, binary_to_atom(Val)} end} \t| {myrecord, val}      \t|\n\n> **Note**\n>\n> Proplists are not handled by Euneus, you must override the `list_encoder` option in the encoder to handle them. Another option is to convert proplists to maps before the encoding. The reason is because it's impossible to know when a list is a proplist and also because a proplist cannot be decoded. See the [Why not more built-in types?](#why-not-more-built-in-types) section.\n\n#","ref":"readme.html#data-mapping"},{"type":"extras","title":"Why not more built-in types? - Overview","doc":"The goal of `Euneus` is to have built-in types that can be encoded and then decoded to the original value. If you have any type that can be encoded and rolled back, feel free to open a [new issue](https://github.com/williamthome/euneus/issues/new) to discuss it.","ref":"readme.html#why-not-more-built-in-types"},{"type":"extras","title":"Differences to Thoas - Overview","doc":"Euneus is based on [Thoas][thoas], so let's discuss the differences.\n\nThe main difference between `Euneus` to `Thoas` is that Euneus gives more control to encoding or decoding data. All encode functions can be overridden and extended and all decoded data can be overridden and transformed.\n\n#","ref":"readme.html#differences-to-thoas"},{"type":"extras","title":"Encode - Overview","doc":"Available encode options:\n\n```erlang\n#{\n    %% nulls defines what terms will be replaced with the null literal (default: ['undefined']).\n    nulls => nonempty_list(),\n    %% encode_binary allow override the binary() encoding.\n    binary_encoder => function((binary(), Opts :: map()) -> iolist()),\n    %% atom_encoder allow override the atom() encoding.\n    atom_encoder => function((atom(), Opts :: map()) -> iolist()),\n    %% integer_encoder allow override the integer() encoding.\n    integer_encoder => function((integer(), Opts :: map()) -> iolist()),\n    %% float_encoder allow override the float() encoding.\n    float_encoder => function((float(), Opts :: map()) -> iolist()),\n    %% list_encoder allow override the list() encoding.\n    list_encoder => function((list(), Opts :: map()) -> iolist()),\n    %% map_encoder allow override the map() encoding.\n    map_encoder => function((map(), Opts :: map()) -> iolist()),\n    %% datetime_encoder allow override the calendar:datetime() encoding.\n    datetime_encoder => function((calendar:datetime(), Opts :: map()) -> iolist()),\n    %% timestamp_encoder allow override the erlang:timestamp() encoding.\n    timestamp_encoder => function((erlang:timestamp(), Opts :: map()) -> iolist()),\n    %% unhandled_encoder allow encode any custom term (default: raise unsupported_type error).\n    unhandled_encoder => function((term(), Opts :: map()) -> iolist()),\n    %% escaper allow override the binary escaping (default: json)\n    escaper => json\n             | html\n             | javascript\n             | unicode\n             | function((binary(), Opts :: map()) -> iolist())\n}\n```\n\nFor example:\n\n```erlang\nEncodeOpts = #{\n    binary_encoder => fun\n        ( >, Opts) ->\n            euneus_encoder:escape_binary( >, Opts);\n        (Bin, Opts) ->\n            euneus_encoder:escape_binary(Bin, Opts)\n    end,\n    unhandled_encoder => fun\n        ({_, _, _, _} = Ip, Opts) ->\n            case inet:ntoa(Ip) of\n                {error, einval} ->\n                    error(invalid_ip);\n                IpStr ->\n                    IpBin = list_to_binary(IpStr),\n                    euneus_encoder:escape_binary(IpBin, Opts)\n            end;\n        (Term, Opts) ->\n            euneus_encoder:throw_unsupported_type_error(Term, Opts)\n    end\n},\nData = #{ > => bar, ipv4 => {127, 0, 0, 1}, none => undefined},\neuneus:encode_to_binary(Data, EncodeOpts).\n%% {ok,  >}\n```\n\n#","ref":"readme.html#encode"},{"type":"extras","title":"Decode - Overview","doc":"Available decode options:\n\n```erlang\n#{\n    %% null_term is the null literal override (default: 'undefined').\n    null_term => term(),\n    %% arrays allow override any array/list().\n    arrays => function((list(), Opts :: map()) -> term()),\n    %% objects allow override any object/map().\n    objects => function((map(), Opts :: map()) -> term()),\n    %% keys allow override the keys from JSON objects.\n    keys => copy\n          | to_atom\n          | to_existing_atom\n          | to_integer\n          | function((binary(), Opts :: map()) -> term()),\n    %% values allow override any other term, like array item or object value.\n    values => copy\n            | to_atom\n            | to_existing_atom\n            | to_integer\n            | function((binary(), Opts :: map()) -> term())\n}\n```\n\nFor example:\n\n```erlang\nDecodeOpts = #{\n    null_term => nil,\n    keys => fun\n        ( >, _Opts) ->\n            foo;\n        (Key, _Opts) ->\n            binary_to_atom(Key)\n    end,\n    values => fun\n        ( >, _Opts) ->\n            {127, 0, 0, 1};\n        (Value, _Opts) ->\n            Value\n    end\n},\nJSON =  >,\neuneus:decode(JSON, DecodeOpts).\n%% {ok,#{foo\"=>  >,\n%%       ipv4 => {127,0,0,1},\n%%       none => nil}}\n```\n\n##","ref":"readme.html#decode"},{"type":"extras","title":"Resuming - Overview","doc":"Euneus permits resuming the decoding when an invalid token is found. Any value can replace the invalid token by overriding the `error_handler` option, e.g.:\n\n```erlang\n1> ErrorHandler = fun\n      (throw, {{token, Token}, Rest, Opts, Input, Pos, Buffer}, _Stacktrace) ->\n          % Instead of throwing the invalid token, it can be replaced.\n          Replacement = foo,\n          euneus_decoder:resume(Token, Replacement, Rest, Opts, Input, Pos, Buffer);\n      (Class, Reason, Stacktrace) ->\n          euneus_decoder:handle_error(Class, Reason, Stacktrace)\n   end.\n\n2> Opts = #{error_handler => ErrorHandler}.\n\n3> euneus:decode( >, Opts).\n% {ok,[foo,foo,#{ > => foo}]}\n```\n\n> **Note**\n>\n> By using `euneus_decoder:resume/6` the replacement will be the `null_term` option.\n\n#","ref":"readme.html#resuming"},{"type":"extras","title":"Why Euneus over Thoas? - Overview","doc":"`Thoas` is incredible, works performant and perfectly fine, but `Euneus` is more flexible, permitting more customizations, and is more performant than Thoas. See the [benchmarks](#benchmarks).\n\nThe motivation for Euneus is [this PR](https://github.com/lpil/thoas/pull/28).","ref":"readme.html#why-euneus-over-thoas"},{"type":"extras","title":"Benchmarks - Overview","doc":"All the benchmarks compare `Euneus` and `Thoas` via [Benchee](https://github.com/bencheeorg/benchee) to obtain the results.\n\nUse `$ make bench.encode` or `$ make bench.decode` to run the benchmarks. Edit the scripts in the `./euneus_bench/script` folder if needed.\n\n> **Note**\n>\n> - Results:\n>\n>   Values in `IPS` (iterations per second), aka how often can the given function be executed within one second (the higher the better - good for graphing), only for run times.\n>   - `Bold`: best IPS;\n>\n> - System info:\n>   - Erlang: 26.1\n>   - Elixir: 1.16.0-dev\n>   - Operating system: Linux\n>   - Available memory: 15.54 GB\n>   - CPU Information: Intel(R) Core(TM) i7-7700HQ CPU @ 2.80GHz\n>   - Number of Available Cores: 8\n>\n> - Benchmark setup:\n>   - warmup: 5\n>   - time: 30\n\n#","ref":"readme.html#benchmarks"},{"type":"extras","title":"Encode - Overview","doc":"> **Note**\n>\n> `Thoas` does not permit any customization.\n\n \n \n| **File**                   \t|  **Euneus** \t|  **Thoas** \t| **Comparison** \t|\n|----------------------------\t|------------:\t|-----------:\t|---------------:\t|\n| blockchain.json            \t|  **9.73 K** \t|     7.86 K \t|          1.24x \t|\n| giphy.json                 \t|  **897.47** \t|     853.31 \t|          1.05x \t|\n| github.json                \t|  **3.14 K** \t|     2.54 K \t|          1.24x \t|\n| govtrack.json              \t|   **12.72** \t|      12.27 \t|          1.04x \t|\n| issue-90.json              \t|   **28.92** \t|      17.50 \t|          1.65x \t|\n| json-generator-pretty.json \t|  **1.16 K** \t|     1.08 K \t|          1.08x \t|\n| json-generator.json        \t|  **1.17 K** \t|     1.08 K \t|          1.08x \t|\n| pokedex.json               \t|      1.63 K \t| **1.73 K** \t|          1.07x \t|\n| utf-8-escaped.json         \t| **11.88 K** \t|    10.57 K \t|          1.12x \t|\n| utf-8-unescaped.json       \t| **12.19 K** \t|    10.83 K \t|          1.13x \t|\n\n#","ref":"readme.html#encode"},{"type":"extras","title":"Decode - Overview","doc":"> **Note**\n>\n> `Thoas` does not permit any customization and does not decode `ISO 8601` dates to erlang term, but Euneus decodes out of the box, for example, `\"1970-01-01T00:00:00Z\"` to `{{1970,01,01},{0,0,0}}` :: [calendar:datetime()](https://www.erlang.org/doc/man/calendar.html#data-types) and `\"1970-01-01T00:00:00.000Z\"` to `{0,0,0}` :: [erlang:timestamp()](https://www.erlang.org/doc/man/os#timestamp-0).\n\n \n \n| **File**                   \t|  **Euneus** \t| **Thoas** \t| **Comparison** \t|\n|----------------------------\t|------------:\t|----------:\t|---------------:\t|\n| blockchain.json            \t|  **7.18 K** \t|    5.78 K \t|          1.24x \t|\n| giphy.json                 \t|  **474.91** \t|    474.75 \t|          1.00x \t|\n| github.json                \t|  **2.33 K** \t|    2.02 K \t|          1.16x \t|\n| govtrack.json              \t|   **16.35** \t|     15.65 \t|          1.04x \t|\n| issue-90.json              \t|   **25.35** \t|     17.70 \t|          1.43x \t|\n| json-generator-pretty.json \t|  **617.33** \t|    542.99 \t|          1.14x \t|\n| json-generator.json        \t|  **728.01** \t|    655.15 \t|          1.11x \t|\n| pokedex.json               \t|  **1.37 K** \t|    1.33 K \t|          1.03x \t|\n| utf-8-escaped.json         \t|  **1.88 K** \t|    1.66 K \t|          1.13x \t|\n| utf-8-unescaped.json       \t| **10.87 K** \t|   10.47 K \t|          1.04x \t|","ref":"readme.html#decode"},{"type":"extras","title":"Credits - Overview","doc":"Euneus is a rewrite of Thoas, so all credits go to [Michał Muskała](https://github.com/michalmuskala), [Louis Pilfold](https://github.com/lpil), also both [Jason][jason] and [Thoas][thoas] contributors. Thanks for the hard work!","ref":"readme.html#credits"},{"type":"extras","title":"Why the name Euneus? - Overview","doc":"Euneus is the twin brother of [Thoas](https://en.wikipedia.org/wiki/Thoas_(son_of_Jason)).","ref":"readme.html#why-the-name-euneus"},{"type":"extras","title":"TODO - Overview","doc":"- [ ] Improve docs\n- [X] Specs\n- [X] Benchmarks\n- [X] Test suites","ref":"readme.html#todo"},{"type":"extras","title":"Sponsors - Overview","doc":"If you like this tool, please consider [sponsoring me](https://github.com/sponsors/williamthome).\nI'm thankful for your never-ending support :heart:\n\nI also accept coffees :coffee:\n\n[![\"Buy Me A Coffee\"](https://www.buymeacoffee.com/assets/img/custom_images/orange_img.png)](https://www.buymeacoffee.com/williamthome)","ref":"readme.html#sponsors"},{"type":"extras","title":"Contributing - Overview","doc":"#","ref":"readme.html#contributing"},{"type":"extras","title":"Issues - Overview","doc":"Feel free to [submit an issue on Github](https://github.com/williamthome/euneus/issues/new).\n\n#","ref":"readme.html#issues"},{"type":"extras","title":"Installation - Overview","doc":"```console\n# Clone this repo\ngit clone git@github.com:williamthome/euneus.git\n\n# Navigate to the project root\ncd euneus\n\n# Compile (ensure you have rebar3 installed)\nrebar3 compile\n```\n\n#","ref":"readme.html#installation"},{"type":"extras","title":"Commands - Overview","doc":"```\n# Benchmark euneus:encode/1\n$ make bench.encode\n```\n\n```\n# Benchmark euneus:decode/1\n$ make bench.decode\n```\n\n```\n# Run all tests\n$ make test\n```\n\n```\n# Run all tests and dialyzer\n$ make check\n```\n\n> **Note**:\n>\n> Open the [Makefile](Makefile) to see all commands.","ref":"readme.html#commands"},{"type":"extras","title":"License - Overview","doc":"Euneus is released under the [Apache License 2.0](LICENSE.md).\n\nEuneus is based off of [Thoas][thoas], which is also Apache 2.0 licensed.\n\nSome elements have their origins in the [Poison library][poison] and were initially licensed under [CC0-1.0](https://creativecommons.org/publicdomain/zero/1.0/).\n\n[jason]: https://github.com/michalmuskala/jason\n[thoas]: https://github.com/lpil/thoas\n[poison]: https://github.com/devinus/poison","ref":"readme.html#license"},{"type":"extras","title":"License","doc":"# Apache License\nVersion 2.0, January 2004\n\nhttp://www.apache.org/licenses/\n\nTERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION","ref":"license.html"},{"type":"extras","title":"1. Definitions. - License","doc":"\"License\" shall mean the terms and conditions for use, reproduction, and\ndistribution as defined by Sections 1 through 9 of this document.\n\n\"Licensor\" shall mean the copyright owner or entity authorized by the copyright\nowner that is granting the License.\n\n\"Legal Entity\" shall mean the union of the acting entity and all other entities\nthat control, are controlled by, or are under common control with that entity.\nFor the purposes of this definition, \"control\" means (i) the power, direct or\nindirect, to cause the direction or management of such entity, whether by\ncontract or otherwise, or (ii) ownership of fifty percent (50%) or more of the\noutstanding shares, or (iii) beneficial ownership of such entity.\n\n\"You\" (or \"Your\") shall mean an individual or Legal Entity exercising\npermissions granted by this License.\n\n\"Source\" form shall mean the preferred form for making modifications, including\nbut not limited to software source code, documentation source, and configuration\nfiles.\n\n\"Object\" form shall mean any form resulting from mechanical transformation or\ntranslation of a Source form, including but not limited to compiled object code,\ngenerated documentation, and conversions to other media types.\n\n\"Work\" shall mean the work of authorship, whether in Source or Object form, made\navailable under the License, as indicated by a copyright notice that is included\nin or attached to the work (an example is provided in the Appendix below).\n\n\"Derivative Works\" shall mean any work, whether in Source or Object form, that\nis based on (or derived from) the Work and for which the editorial revisions,\nannotations, elaborations, or other modifications represent, as a whole, an\noriginal work of authorship. For the purposes of this License, Derivative Works\nshall not include works that remain separable from, or merely link (or bind by\nname) to the interfaces of, the Work and Derivative Works thereof.\n\n\"Contribution\" shall mean any work of authorship, including the original version\nof the Work and any modifications or additions to that Work or Derivative Works\nthereof, that is intentionally submitted to Licensor for inclusion in the Work\nby the copyright owner or by an individual or Legal Entity authorized to submit\non behalf of the copyright owner. For the purposes of this definition,\n\"submitted\" means any form of electronic, verbal, or written communication sent\nto the Licensor or its representatives, including but not limited to\ncommunication on electronic mailing lists, source code control systems, and\nissue tracking systems that are managed by, or on behalf of, the Licensor for\nthe purpose of discussing and improving the Work, but excluding communication\nthat is conspicuously marked or otherwise designated in writing by the copyright\nowner as \"Not a Contribution.\"\n\n\"Contributor\" shall mean Licensor and any individual or Legal Entity on behalf\nof whom a Contribution has been received by Licensor and subsequently\nincorporated within the Work.","ref":"license.html#1-definitions"},{"type":"extras","title":"2. Grant of Copyright License. - License","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable copyright license to reproduce, prepare Derivative Works of,\npublicly display, publicly perform, sublicense, and distribute the Work and such\nDerivative Works in Source or Object form.","ref":"license.html#2-grant-of-copyright-license"},{"type":"extras","title":"3. Grant of Patent License. - License","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable (except as stated in this section) patent license to make, have\nmade, use, offer to sell, sell, import, and otherwise transfer the Work, where\nsuch license applies only to those patent claims licensable by such Contributor\nthat are necessarily infringed by their Contribution(s) alone or by combination\nof their Contribution(s) with the Work to which such Contribution(s) was\nsubmitted. If You institute patent litigation against any entity (including a\ncross-claim or counterclaim in a lawsuit) alleging that the Work or a\nContribution incorporated within the Work constitutes direct or contributory\npatent infringement, then any patent licenses granted to You under this License\nfor that Work shall terminate as of the date such litigation is filed.","ref":"license.html#3-grant-of-patent-license"},{"type":"extras","title":"4. Redistribution. - License","doc":"You may reproduce and distribute copies of the Work or Derivative Works thereof\nin any medium, with or without modifications, and in Source or Object form,\nprovided that You meet the following conditions:\n\n1. You must give any other recipients of the Work or Derivative Works a copy of\n   this License; and\n\n2. You must cause any modified files to carry prominent notices stating that\n   You changed the files; and\n\n3. You must retain, in the Source form of any Derivative Works that You\n   distribute, all copyright, patent, trademark, and attribution notices from\n   the Source form of the Work, excluding those notices that do not pertain to\n   any part of the Derivative Works; and\n\n4. If the Work includes a \"NOTICE\" text file as part of its distribution, then\n   any Derivative Works that You distribute must include a readable copy of the\n   attribution notices contained within such NOTICE file, excluding those\n   notices that do not pertain to any part of the Derivative Works, in at least\n   one of the following places: within a NOTICE text file distributed as part\n   of the Derivative Works; within the Source form or documentation, if\n   provided along with the Derivative Works; or, within a display generated by\n   the Derivative Works, if and wherever such third-party notices normally\n   appear. The contents of the NOTICE file are for informational purposes only\n   and do not modify the License. You may add Your own attribution notices\n   within Derivative Works that You distribute, alongside or as an addendum to\n   the NOTICE text from the Work, provided that such additional attribution\n   notices cannot be construed as modifying the License.\n\nYou may add Your own copyright statement to Your modifications and may provide\nadditional or different license terms and conditions for use, reproduction, or\ndistribution of Your modifications, or for any such Derivative Works as a whole,\nprovided Your use, reproduction, and distribution of the Work otherwise complies\nwith the conditions stated in this License.","ref":"license.html#4-redistribution"},{"type":"extras","title":"5. Submission of Contributions. - License","doc":"Unless You explicitly state otherwise, any Contribution intentionally submitted\nfor inclusion in the Work by You to the Licensor shall be under the terms and\nconditions of this License, without any additional terms or conditions.\nNotwithstanding the above, nothing herein shall supersede or modify the terms of\nany separate license agreement you may have executed with Licensor regarding\nsuch Contributions.","ref":"license.html#5-submission-of-contributions"},{"type":"extras","title":"6. Trademarks. - License","doc":"This License does not grant permission to use the trade names, trademarks,\nservice marks, or product names of the Licensor, except as required for\nreasonable and customary use in describing the origin of the Work and\nreproducing the content of the NOTICE file.","ref":"license.html#6-trademarks"},{"type":"extras","title":"7. Disclaimer of Warranty. - License","doc":"Unless required by applicable law or agreed to in writing, Licensor provides the\nWork (and each Contributor provides its Contributions) on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied,\nincluding, without limitation, any warranties or conditions of TITLE, NON-\nINFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are\nsolely responsible for determining the appropriateness of using or\nredistributing the Work and assume any risks associated with Your exercise of\npermissions under this License.","ref":"license.html#7-disclaimer-of-warranty"},{"type":"extras","title":"8. Limitation of Liability. - License","doc":"In no event and under no legal theory, whether in tort (including negligence),\ncontract, or otherwise, unless required by applicable law (such as deliberate\nand grossly negligent acts) or agreed to in writing, shall any Contributor be\nliable to You for damages, including any direct, indirect, special, incidental,\nor consequential damages of any character arising as a result of this License or\nout of the use or inability to use the Work (including but not limited to\ndamages for loss of goodwill, work stoppage, computer failure or malfunction, or\nany and all other commercial damages or losses), even if such Contributor has\nbeen advised of the possibility of such damages.","ref":"license.html#8-limitation-of-liability"},{"type":"extras","title":"9. Accepting Warranty or Additional Liability. - License","doc":"While redistributing the Work or Derivative Works thereof, You may choose to\noffer, and charge a fee for, acceptance of support, warranty, indemnity, or\nother liability obligations and/or rights consistent with this License. However,\nin accepting such obligations, You may act only on Your own behalf and on Your\nsole responsibility, not on behalf of any other Contributor, and only if You\nagree to indemnify, defend, and hold each Contributor harmless for any liability\nincurred by, or claims asserted against, such Contributor by reason of your\naccepting any such warranty or additional liability.\n\nEND OF TERMS AND CONDITIONS\n\nCopyright 2023, William Fank Thomé  .\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\nhttp://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"license.html#9-accepting-warranty-or-additional-liability"}],"content_type":"text/plain"}